"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
const engine_1 = __importDefault(require("./engine"));
const yargs = require("yargs");
let argv = yargs
    .option("dry-run", {
    type: "boolean",
    description: "Only output the docset entries and don't create the docset",
})
    .option("config", {
    alias: "c",
    type: "string",
    description: "config file name / path",
})
    .option("keep", {
    alias: "k",
    type: "boolean",
    description: "keep output directory",
})
    .option("file", {
    alias: "f",
    type: "string",
    description: "output file name",
});
const configFilePath = util_1.normalizePath(argv.argv.c || "docsetconfig.js");
let options = require(configFilePath);
if (options.default) {
    options = options.default;
}
if (options.plugins) {
    options.plugins = options.plugins.map((plugin) => {
        plugin = plugin.default || plugin;
        return Object.assign(Object.assign({}, plugin), { plugin: plugin.plugin.default || plugin.plugin });
    });
    for (let i = 0; i < options.plugins.length; i++) {
        const plugin = options.plugins[i];
        if (plugin.plugin.includeCliOptions) {
            argv = plugin.plugin.includeCliOptions(argv);
        }
    }
}
argv = argv.argv;
engine_1.default(options, argv)
    .catch((e) => {
    console.error(e);
    process.exit(1);
})
    .then(() => "process complete");
//# sourceMappingURL=cli.js.map